from freemet.services.service import Service
import wx
import time

_ = wx.GetTranslation

pages = ["USAF", "DWD", "Temp Stuttgart 1", "Temp Stuttgart 2", "Temp Nancy",
         _("About")]

class Analysis(Service):
    def __init__(self):
        Service.__init__(self, "analysis", _("Analysis maps"), 4, 60,
                         pages, "maps")
        
    def Load(self, download, progressDlg=None, progressCount=0):
        t = time.gmtime()
        if t.tm_hour < 13: tempHour = "00"
        else: tempHour = "12"
        
        downloads = [("http://www.wetterzentrale.de/pics/semb0.gif",
                      "analysis_usaf.gif"),
                      ("http://www.met.fu-berlin.de/de/wetter/maps/anabwkna.gif",
                       "analysis_dwd.gif"),
                      ("http://profi.wetteronline.de/url/daten/profi/de/temps/"
                       "10739_%s.gif" % tempHour,
                       "analysis_tempstgt1.gif"),
                      ("http://www.wetterzentrale.de/pics/10739s.gif",
                       "analysis_tempstgt2.gif"),
                      ("http://www.wetterzentrale.de/pics/07180s.gif ",
                       "analysis_tempnancy.gif")]
        return self.Download(download, downloads, progressDlg, progressCount)
    
    def CreatePage(self, index):
        def ScrolledWindow(img):
            p = wx.ScrolledWindow(Service.notebook, -1)
            p.SetScrollRate(10, 10)
            
            sizer = wx.BoxSizer(wx.HORIZONTAL)
            sizer.Add(self.AddImageNotebookPage(p, img))
            p.SetSizer(sizer)
            return p
        
        if index == pages.index("USAF"):
            p = ScrolledWindow("analysis_usaf.gif")
        
        elif index == pages.index("DWD"):
            p = ScrolledWindow("analysis_dwd.gif")
            
        elif index == pages.index("Temp Stuttgart 1"):
            p = ScrolledWindow("analysis_tempstgt1.gif")
            
        elif index == pages.index("Temp Stuttgart 2"):
            p = ScrolledWindow("analysis_tempstgt2.gif")
            
        elif index == pages.index("Temp Nancy"):
            p = ScrolledWindow("analysis_tempnancy.gif")
            
        elif index == pages.index(_("About")):
            descr = _("Some weather analysis maps show how the weather is\n"\
                      "right now. There are also two temp diagrams for\n"
                      "predicting clouds, thermal upwinds, etc.")
            p = self.CreateAboutPage(descr, "(c) 2008 Tobias Wulff", "GPL 2")
            
        return p
    
def load(): return Analysis()