from freemet.services.service import Service
import wx
import wx.animate
import urllib2, re

_ = wx.GetTranslation

reBaseUrl = "base href=\"(.*)\"/"
reListUrl = "a href=\"(\?.*)\" target"
reEddsUrl = "a href=\"(\?[^<>]*__EDDS__node.html__nnn%3Dtrue)\" target="
reReport = "<div class=\"blockBodyPre\">((\n|.[^<>])*)</div>"
startUrl = "http://www.dwd.de/bvbw/appmanager/bvbw/dwdwwwDesktop/?_nfpb=true&_pageLabel=_dwdwww_spezielle_nutzer_luftfahrt&T52801598661179816505191gsbDocumentPath=Content%2FLuftfahrt%2Fteaser__luftsportberichte.html&_state=maximized&_windowLabel=T52801598661179816505191&lastPageLabel=_dwdwww_spezielle_nutzer_luftfahrt"
eddsUrl = "?_nfpb=true&_pageLabel=_dwdwww_spezielle_nutzer_luftfahrt&T52801598661179816505191gsbDocumentPath=Navigation%2FLuftfahrt%2FPublic%2FSegelflugberichte%2FSegelflugbericht__EDDS__node.html__nnn%3Dtrue"
airportUrl = "?_nfpb=true&_pageLabel=_dwdwww_spezielle_nutzer_luftfahrt&T52801598661179816505191gsbDocumentPath=Navigation%2FLuftfahrt%2FPublic%2FSegelflugberichte%2FSegelflugbericht__AIRPORT__node.html__nnn%3Dtrue"

airports = ["EDDS", "EDDF", "EDDM", "EDDL", "EDDP", "EDDI", "EDDV", "EDDH"]
pages = airports + [_("About")]

class DwdGlidingReport(Service):
    def __init__(self):
        Service.__init__(self, "dwdgliding", "DWD Segeflugwetterbericht",
                         0, 0, pages, "forecast")
        
        self.reports = {}
        
    def Load(self, download, progressDlg=None, progressCount=0):
        self.reports = {}
        
        if not download: return 0, False
        
        s = self.__DownloadUrl(startUrl)        
        baseurl = self.__FindString(reBaseUrl, s)
        
        if not baseurl: return 0, False
        
        for airport in airports:
            url = baseurl + airportUrl.replace("AIRPORT", airport)
        
            s = self.__DownloadUrl(url)
            self.reports[airport] = self.__FindString(reReport, s)
        
        return 0, False
            
    def CreatePage(self, index):
        if index == pages.index(_("About")):
            descr = _("This service downloads all gliding forecasts\n" \
                      "available from the German Weather Service (DWD).")
            p = self.CreateAboutPage(descr, "(c) 2008 Tobias Wulff", "GPL 2")
            
        else:
            airport = airports[index]
            
            p = wx.Panel(Service.notebook, -1)
            
            p = wx.ScrolledWindow(Service.notebook, -1)
            p.SetScrollRate(10, 10)
            sizer = wx.BoxSizer(wx.VERTICAL)
            
            if self.reports:
                sizer.Add(wx.StaticText(p, -1, self.reports[airport]))
            
            p.SetSizer(sizer)
        
        return p
    
    def __DownloadUrl(self, url):
        userAgent = 'Mozilla/4.0 (compatible; MSIE 5.5; Windows NT)'
        headers = {"User-Agent": userAgent}
        
        try:
            req = urllib2.Request(url)
            response = urllib2.urlopen(req)
            s = response.read()
            response.close()
            return s
        except urllib2.URLError, e:
            print "Error downloading " + url
            print "Error code: " + str(e.code)
            return None
        
    def __FindString(self, regexp, s):
        r = re.compile(regexp)
        match = r.search(s)
    
        if not match:
            print "Error: No match for regexp \"" + regexp + "\" found"
            return ""
    
        return match.groups()[0].replace("amp;", "")

def load(): return DwdGlidingReport()