from freemet.services.service import Service
import os
import wx
import wx.animate

_ = wx.GetTranslation

mapUrl = "http://www.meteox.com/kaart.gif"
rainUrl = "http://www.meteox.com/images.aspx?jaar=-3&voor=&soort=loop1uur&c=&n=&tijdid="
cloudsUrl = "http://world.meteox.com/radareu/loop_ir.gif"
lightningUrl = "http://world.meteox.com/onweer/loop_onweer.gif"
predictionUrl = "http://www.meteox.com/images.aspx?jaar=-3&voor=&soort=exp&c=&n=&tijdid="

pages = [_("Rain"), _("Clouds+Rain"), _("3h Prediction"), _("Lightning"), _("About")]

class Meteox(Service):
    def __init__(self):
        # |pages| + 1 because of separate map file
        Service.__init__(self, "meteox", "Meteox", len(pages) + 1, 10, pages,
                         "satellite")
        self.animations = None
        
    def Load(self, download, progressDlg=None, progressCount=0):        
        downloads = [(mapUrl, "map.gif"),
                     (rainUrl, "rain.gif"),
                     (cloudsUrl, "clouds.gif"),
                     (predictionUrl, "prediction.gif"),
                     (lightningUrl, "lightning.gif")]
        return self.Download(download, downloads, progressDlg, progressCount)
            
    def CreatePage(self, index):
        if self.animations == None: self.animations = []
            
        if index == pages.index(_("Rain")):
            p = wx.Panel(Service.notebook, -1)
            self.AddImageNotebookPage(p, "map.gif")
            ani = self.AddAnimatedImageNotebookPage(p, "rain.gif")
            assert ani
            try:
                self.animations[0] = ani
            except:
                self.animations.append(ani)
        
        elif index == pages.index(_("Clouds+Rain")):
            p = wx.Panel(Service.notebook, -1)
            self.AddImageNotebookPage(p, "map.gif")
            ani = self.AddAnimatedImageNotebookPage(p, "clouds.gif")
            assert ani
            try:
                self.animations[1] = ani
            except:
                self.animations.append(ani)
                
        elif index == pages.index(_("3h Prediction")):
            # Remove first seven frames (no prediction)
            path = Service.downloadPath + "meteox/"
            pathSrc = path
            os.system("convert " + path + "prediction.gif -delete 0-5 " +\
                      path + "predictionOnly.gif")
            
            p = wx.Panel(Service.notebook, -1)
            self.AddImageNotebookPage(p, "map.gif")
            ani = self.AddAnimatedImageNotebookPage(p, "predictionOnly.gif")
            assert ani
            try:
                self.animations[2] = ani
            except:
                self.animations.append(ani)
        
        elif index == pages.index(_("Lightning")):
            p = wx.Panel(Service.notebook, -1)
            ani = self.AddAnimatedImageNotebookPage(p, "lightning.gif")
            assert ani
            try:
                self.animations[3] = ani
            except:
                self.animations.append(ani)
        
        elif index == pages.index(_("About")):
            descr = _("...")
            p = self.CreateAboutPage(descr, "(c) 2008 Tobias Wulff", "GPL 2")
        
        return p
        
    def ActivateNotebookPage(self, index):
        if index >= len(self.animations): return
        self.animations[index].Play()
            
    def DeactivateNotebookPage(self, index):
        if index >= len(self.animations): return
        
        # Stop doesn't seem to work, animation on deactivated page
        # keeps running
        self.animations[index].Stop()
        
def load(): return Meteox()