from freemet.services.service import Service
from urllib2 import urlopen
import wx
import wx.animate
from freemet.config import config

_ = wx.GetTranslation

baseurl = "http://www.sat24.com/images.php?"

pages = [_("Visible"), _("IR"), _("West Vis"), _("About")]

class Sat24(Service):
    def __init__(self):
        Service.__init__(self, "sat24", "Sat24", 3, 10, pages, "satellite")
        self.animations = None
        
    def Load(self, download, progressDlg=None, progressCount=0):        
        downloads = [(baseurl + "country=de&sat=", "sat24.gif"),
                     (baseurl + "country=de&sat=ir", "sat24_ir.gif"),
                     (baseurl + "country=fr&sat=", "sat24_fr.gif")]
        return self.Download(download, downloads, progressDlg, progressCount)
            
    def CreatePage(self, index):
        if self.animations == None: self.animations = [None, None, None]
            
        # Put image in panel vis
        if index == pages.index(_("Visible")):
            p = wx.Panel(Service.notebook, -1)
            ani = self.AddAnimatedImageNotebookPage(p, "sat24.gif")
            assert ani
            self.animations[0] = ani
            
        # Put image in panel ir
        elif index == pages.index(_("IR")):
            p = wx.Panel(Service.notebook, -1)
            ani = self.AddAnimatedImageNotebookPage(p, "sat24_ir.gif")
            assert ani
            self.animations[1] = ani
        
        # Put image in panel France
        elif index == pages.index(_("West Vis")):
            p = wx.Panel(Service.notebook, -1)
            ani = self.AddAnimatedImageNotebookPage(p, "sat24_fr.gif")
            assert ani
            self.animations[2] = ani
            
        # About page
        elif index == 3:
            descr = _("This service downloads the latest animated images from\n"\
                      "sat24.com. There are two sequences for Germany, one\n"\
                      "in visible colors and the other one in infrared.\n"\
                      "There's also a sequence for France to see the weather\n"\
                      "approaching Central Europe from the west.") 
            p = self.CreateAboutPage(descr, "(c) 2008 Tobias Wulff", "GPL 2")
            
        return p
        
    def ActivateNotebookPage(self, index):
        if index >= len(self.animations): return
        self.animations[index].Play()
            
    def DeactivateNotebookPage(self, index):
        if index >= len(self.animations): return
        
        # Stop doesn't seem to work, animation on deactivated page
        # keeps running
        self.animations[index].Stop()
        
def load(): return Sat24()